#!/usr/bin/python   
# -*- coding: utf-8 -*-

from lxml import etree
import time
from time import strftime

global MAX_ATTEMP_NUMBER
MAX_ATTEMP_NUMBER = 3
global MAX_ORDER_DATA_LENGTH
MAX_ORDER_DATA_LENGTH = 1048576
global AUTH_KEY_LENGTH
AUTH_KEY_LENGTH = 2048
global SIGN_KEY_LENGTH
SIGN_KEY_LENGTH = 2048
global ENCRYPT_KEY_LENGTH
ENCRYPT_KEY_LENGTH = 2048
global EBICS_VERSION
EBICS_VERSION = "H003"
global EBICS_REVISION
EBICS_REVISION = "1"
global PRODUCT_VERSION
#PRODUCT_VERSION = "kopiLeft Dev 1.0"
PRODUCT_VERSION = "EbicsPy 0.1"


def get_timestamp():
    #FIXME : get the real milliseconds value
	return strftime("%Y-%m-%dT%H:%M:%S.123Z", time.gmtime())

def validateXML(xml):
	print xml
	print '====================================='
	if EBICS_VERSION == 'H003' :
		schema_root = etree.parse('schemas_version_H003_EBICS2.4/ebics.xsd')
	else:
		schema_root = etree.parse('schemas_version_H004_EBICS2.5/ebics.xsd')
	schema = etree.XMLSchema(schema_root)
	parser = etree.XMLParser(schema = schema)
	root = etree.fromstring(xml, parser)

class FileSystemLogger : 
    def __init__(self, path="log"):
        self.path = path
        
    def write(self, title, string):
        print title, string
        f = open(join(self.path, title), 'w')
        f.write(string)
        f.close()

class XMLStorageService : 
    def __init__(self, path):
        self.path = path

        
class FileSystemStorageService : 
    def __init__(self, root=".", key_repository="/keys"):
        self.root = root
        self.key_repository = key_repository
        
    def saveBankKeys(self, auth_modulus, auth_exponent, encrypt_modulus, encrypt_exponent):
        f = open(join(self.key_repository, self.getName()+"_"+auth_version+"_modulus"), "w")
        f.write(str(long(binascii.hexlify(auth_modulus), 16)))
        f.close()
        f = open(join(self.key_repository, self.getName()+"_"+auth_version+"_public_exponent"), "w")
        f.write(str(int(auth_exponent, 16)))
        f.close()
        f = open(join(self.key_repository, self.getName()+"_"+encrypt_version+"_modulus"), "w")
        f.write(str(long(binascii.hexlify(encrypt_modulus), 16)))
        f.close()
        f = open(join(self.key_repository, self.getName()+"_"+encrypt_version+"_public_exponent"), "w")
        f.write(str(int(encrypt_exponent, 16)))
        f.close()
        
        
    def partner_keys_already_exists(self, partnerName):
        partner_keys_already_exists = True
        k_partner_list = [join(self.key_repository, partnerName+'_auth_public_key.pem')]
        for key_file in k_partner_list:
            if not exists(key_file):
                partner_keys_already_exists = False
        return partner_keys_already_exists
        
    def bank_keys_already_exists(self, bank.getName(), auth_version):
        bank_keys_already_exists = True
        k_bank_list = [join(self.key_repository ,bank.getName()+'_'+auth_version+'_modulus')]
        for key_file in k_bank_list:
            if not exists(key_file):
                bank_keys_already_exists = False
        return bank_keys_already_exists
        
    def getBankAuthKeyHash(self):
        return input("Please enter the bank's auth key hash : ")

    def getBankEncryptKeyHash(self):
        return input("Please enter the bank's encrypt key hash : ")

    def saveLetter(self, letter, letterType, partnerName, bankName):
        letter_path = join(self.key_repository, letterType+"_"+partner.getName()+"_"+bank.getName()+".txt")
        f = open(letter_path, 'w')
        f.write(letter)
        f.close()
        

    def loadCertificate(self, type_certificate, partnerName):
        path_certificate = join(self.key_repository, partnerName+'_'+type_certificate+'.crt'
        f = open(path_certificate, "r")
        certificate = ""
        for line in f :
            certificate += line.strip()
        certificate = certificate.replace('-----BEGIN CERTIFICATE-----', '').replace('-----END CERTIFICATE-----', '')
        return certificate
        
    def getPartnerKey(self, partnerName, keyType, keyLevel):
        path = join(self.key_repository, partnerName+'_'+keyType+'_'+keyLevel+'_key.pem')
        f = open(path, "r")
        res = f.read()
        f.close()
        return res
        
    def getBankKeyComponent(self, bankName, keyComponent, keyVersion):
        path = join(self.key_repository, bankName+"_"+keyVersion+"_"+keyComponent)
        f = open(path, "r")
        res = long(f.read())
        f.close()
        return res

    def saveCertificate(self, type_certificate, partnerName, content, cert_req):
        path_certificate = join(self.key_repository, partnerName+'_'+type_certificate+'.crt'
        f = open(path_certificate, 'w')
        f.write(content)
        f.close()
        path_certificate_req = join(self.key_repository, partnerName+'_'+type_certificate+'.csr'
        f = open(path_certificate__req, 'w')
        f.write(content)
        f.close()
        
    def saveKey(self, function, owner, privacity, key) :
        path = join(self.key_repository, owner+"_"+function+"_"+privacity+"_key.pem")
        f = open(path, 'w')
        f.write(key)
        f.close()
        
    def saveCA(self, function, owner, cert, ca_key, ca_cert, ca_serial):
        path = join(self.key_repository, owner+"_"+function+"_"+privacity+"_CAkey.pem")
        f = open(path, 'w')
        f.write(ca_key)
        f.close()
        path = join(self.key_repository, owner+"_"+function+"_"+privacity+"_CAcert.crt")
        f = open(path, 'w')
        f.write(ca_cert)
        f.close()
        path = join(self.key_repository, owner+"_"+function+"_"+privacity+"_CAserial.srl")
        f = open(path, 'w')
        f.write(ca_serial)
        f.close()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
